/* NetStats - IRC Statistical Services
** Copyright (c) 1999 Adam Rutter, Justin Hammond
** http://codeworks.kamserve.com
*
** Based from GeoStats 1.1.0 by Johnathan George net@lite.net
*
** NetStats CVS Identification
** $Id$
*/

#include "stats.h"

void strip(char *line)
{
	char *c;

	if ((c = strchr(line, '\n')))	*c = '\0';
	if ((c = strchr(line, '\r')))	*c = '\0';
}

void ConfLoad()
{
	FILE *fp;
	char buf[BUFSIZE];
	char *s;

	if ((fp = fopen(CONFIG_NAME, "r")) == NULL) {
		printf("Unable to open configuration file (%s)\n", CONFIG_NAME);
		exit(0);
	}

	while (fgets(buf, BUFSIZE, fp)) {
		if (buf[0] == '#')
			continue;
		s = strtok(buf, " ");
		if (!strcmp(s, "SERVER_NAME")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.name, s, sizeof(me.name));
		} else if (!strcmp(s, "SERVER_PORT")) {
			s = strtok(NULL, "\n");
			me.port = atoi(s);
		} else if (!strcmp(s, "CONNECT_TO")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.uplink, s, sizeof(me.uplink));
		} else if (!strcmp(s, "CONNECT_PASS")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.pass, s, sizeof(me.pass));
                } else if (!strcasecmp(s, "SERVER_INFOLINE")) {
                        s = strtok(NULL, "\n");
                        log("%s (pray)", s);
                        strip(s);
                        memcpy(me.infoline, s, sizeof(me.infoline));
                        log("%s", me.infoline); 
                } else if (!strcmp(s, "STATSERV_NETNAME")) {
                        s = strtok(NULL, "\n");
                        strip(s);
                        memcpy(me.netname, s, sizeof(me.netname));
                        log("%s", me.netname); 
		} else if (!strcmp(s, "RECONNECT_TIME")) {
			s = strtok(NULL, "\n");
			me.r_time = atoi(s);
		} else if (!strcmp(s, "LAG_NOTICE")) {
			s = strtok(NULL, "\n");
			me.lag_time = atoi(s);
		} else if (!strcmp(s, "STATSERV_HOST")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(StatServ.host, s, sizeof(StatServ.host));
		} else if (!strcmp(s, "ICQ_HOST")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(IcqServ.host, s, sizeof(IcqServ.host));
		} else if (!strcmp(s, "ICQ_PASSWORD")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(IcqServ.passwd, s, sizeof(IcqServ.passwd));
		} else if (!strcmp(s, "ICQ_USER")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(IcqServ.user, s, sizeof(IcqServ.user));
		} else if (!strcmp(s, "STATSERV_USER")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(StatServ.user, s, sizeof(StatServ.user));
		} else if (!strncmp(s, "ENABLE_SPAM", 11)) {
			me.enable_spam = 1;
		} else if (!strncmp(s, "ONLYOPERS", 9)) {
			me.onlyopers = 1;
		} else if (!strcmp(s, "STATSERV_NICK")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(s_StatServ, s, MAXNICK);
		} else if (!strncmp(s, "WANT_PRIVMSG", 12)) {
			me.want_privmsg = 1;
		} else if (!strcmp(s, "SERVICES_NAME")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.services_name, s, MAXHOST);
		} else if (!strcmp(s, "SEND_EXTREME_LAG_NOTICES_TO")) {
			me.send_extreme_lag_notices = 1;
		} else if (!strcmp(s, "PUBLISH_LAG")) {
			me.noticelag = 1;
		} else if (!strcmp(s, "SERVICES_CHAN")) {
			s = strtok(NULL, "\n");
			strip(s);
			me.chan = sstrdup(s);
		}
	}
	fclose(fp);
}

void rehash()
{
	/* nothing, yet */
}
