/* NetStats - IRC Statistical Services
** Copyright (c) 1999 Adam Rutter, Justin Hammond
** http://codeworks.kamserve.com
*
** Based from GeoStats 1.1.0 by Johnathan George net@lite.net
*
** NetStats CVS Identification
** $Id$
*/

#include "stats.h"

const char *ss_help[] = {
"*** Statistics Help ***",
"",
"Commands:",
"\2SERVER\2     Request information about a server.",
"\2MAP\2        Show the network map.",
"\2UPTIME\2     Statistics on Statistics.",
"\2NETSTATS\2   General Network Statistics.",
"\2DAILY\2      Daily Network Statistics.",
"\2TLD\2        Show what country a TLD represents.",
"\2TLDMAP\2     Statistics on TLD's.",
"\2OPERLIST\2   Show a listing of on-line IRCops.",
"\2BOTLIST\2    Show a listing of on-line BOTS.",
"\2VERSION\2    Shows you the current StatServ Version.",
"",
"End of Help.",
NULL
};

const char *ss_myuser_help[] = {
"",
"*** Additional Commands For Tech Admins!***",
"",
"\2SHUTDOWN\2   Shutdown NeoStats.",
"\2RELOAD\2     Force NeoStats to Reload Itself.",
"\2RESET\2      DELETES data files and starts stats over new!",
"\2JOIN\2       Join a Channel.",
"\2STATS\2      Modify Statistic Entries.",
"\2LOGS\2       View logfiles.",
"\2RAW\2        Send a Raw Command from this Server!",
"End of Help",
NULL
};

const char *ss_coder_help[] = {
"",
"*** Additional Commands For Coders!!***",
"",
"\2Debug\2      Toggle Debuging Mode!",
"               Warning. Running this Command on a Popular Network",
"               Can Flood you of the Server.",
"               \2Use With Caution\2",
"",
"End of Help",
NULL
};

const char *ss_server_help[] = {
"*** Statistics: \2SERVER\2 Help ***",
"",
"Usage: \2SERVER \37<server name>\37\2",
"",
"Provides you with statistics on a",
"specific server.",
"",
"End of Help.",
NULL
};

const char *ss_raw_help[] = {
"*** Statistics: \2RAW\2 Help ***",
"",
"Usage: \2RAW \37Command\37\2",
"",
"Allow you to send Raw IRC commands from this Server",
"Nothing is Returned to the User after a Raw Command",
"",
"End of Help.",
NULL
};


const char *ss_debug_help[] = {
"*** Statistics: \2DEBUG\2 Help ***",
"",
"Usage: \2DEBUG\2",
"",
"This Toggles the Debug Command, Introducing a New User on the Server called",
"stats_debug. Any User that has their Coder Flag set will Recieve Debuging Information",
"",
"On a Large Network, this Command should be used considered Dangerous as a Large amount of Information may be sent to you.",
"End of Help.",
NULL
};

const char *ss_map_help[] = {
"*** Statistics: \2MAP\2 Help ***",
"",
"Usage: \2MAP\2",
"",
"Provides a server listing with",
"minimal statistics.",
"",
"End of Help.",
NULL
};

const char *ss_netstats_help[] = {
"*** Statistics: \2NETSTATS\2 Help ***",
"",
"Usage: \2NETSTATS\2",
"",
"Provides information about the",
"performance of the network.",
"",
"End of Help.",
NULL
};

const char *ss_daily_help[] = {
"*** Statistics: \2DAILY\2 Help ***",
"",
"Usage: \2DAILY\2",
"",
"Provides information about records",
"that have been set today.",
"",
"End of Help.",
NULL
};

const char *ss_tld_help[] = {
"*** Statistics: \2TLD\2 Help ***",
"Usage: \2TLD \37top_level_domain\37\2",
"",
"Provides the country-name",
"for a specific TLD.  An example",
"of a TLD is \2.NET\2",
"",
"End of Help.",
NULL
};

const char *ss_tld_map_help[] = {
"*** Statistics: \2TLDMAP\2 Help ***",
"Usage: \2TLDMAP\2",
"",
"Shows the network map in",
"relation to top level domains.",
"",
"End of Help.",
NULL
};

const char *ss_operlist_help[] = {
"*** Statistics: \2OPERLIST\2 Help ***",
"Usage: \2OPERLIST (\37options|server_name\37)\2",
"",
"Shows a listing of IRCops.",
"",
"Flags:",
" \2NOAWAY\2   Don't show opers that are set away.",
" \2TECH\2     Only Show Tech Admins on the Network.",
" \2NET\2      Only Show Net Admins on the Network.",
" \2BOTS\2     Show Online Bots.",
" \2SERVER\2   Only show opers on that server.",
"",
"End of Help.",
NULL
};

const char *ss_botlist_help[] = {
"*** Statistics: \2BOTLIST\2 Help ***",
"Usage: \2BOTLIST\2",
"",
"Shows all current bots on the network.",
"(umode +B users)",
"",
"End of Help.",
NULL
};

const char *ss_version_help[] = {
"*** Statistics: \2VERSION\2 Help ***",
"Usage: \2VERSION\2",
"",
"Shows the current StatServ Version.",
"",
"End of Help.",
NULL
};

const char *ss_shutdown_help[] = {
"*** Statistics: \2SHUTDOWN\2 Help ***",
"Usage: \2SHUTDOWN\2 <REASON>",
"",
"Force NeoStats to exit immediately.",
"This command should be used wisely.",
"<REASON> is optional.",
"",
"End of Help.",
NULL
};

const char *ss_reload_help[] = {
"*** Statistics: \2RELOAD\2 Help ***",
"Usage: \2RELOAD\2 <REASON>",
"",
"Force NeoStats to Reload Itself.",
"This command will cause StatServ to split from",
"the network and reload datafiles and connect.",
"This command SHOULD be used wisely.",
"<REASON> is optional.",
"",
"End of Help.",
NULL
};

const char *ss_reset_help[] = {
"*** Statistics: \2RESET\2 Help ***",
"Usage: \2RESET\2",
"",
"Force NeoStats to DELETE datafiles and",
"re-connect to the network.  Note: this",
"will reset all statistics.",
"EVIL EVIL command ;)",
"",
"End of Help.",
NULL
};

const char *ss_stats_help[] = {
"*** Statistics: \2STATS\2 Help ***",
"Usage: \2STATS \37[DEL|LIST|COPY]\37\2",
"",
"\2LIST\2  List all database entries.",
"\2DEL \37name\37\2  Remove an entry.",
"\2COPY \37name newname\37\2  Copy an entry.",
"",
"End of Help.",
NULL
};

const char *ss_logs_help[] = {
"*** Statistics: \2LOGS\2 Help ***",
"Usage: \2LOGS\2",
"",
"Sends today's logfile via PRIVMSG/NOTICE",
"",
"End of Help.",
NULL
};

const char *ss_join_help[] = {
"*** Statistics: \2JOIN\2 Help ***",
"Usage: \2JOIN <Channel>\2",
"",
"Get StatServ to Join a Channel",
"It will then Echo Events as they happen to that Channel, So it Shouldn't Join Public Channels",
"",
"End of Help.",
NULL
};

const char *qs_help[] = {
"*** Quake Help ***",
"",
"Commands:",
"\2SERVER\2     Request information about a server.",
"\2LIST\2       Receive a listing of Q2 servers.",
"\2ADD\2        Request that a server be added.",
"\2DEL\2        Request that a server be deleted.",
"\2FILES\2      Receive a listing of available files.",
"",
"End of Help.",
NULL
};
