/* NetStats - IRC Statistical Services
** Copyright (c) 1999 Adam Rutter, Justin Hammond
** http://codeworks.kamserve.com
*
** Based from GeoStats 1.1.0 by Johnathan George net@lite.net
*
** NetStats CVS Identification
** $Id$
*/

#include "stats.h"
extern const char version_date[], version_time[];
extern const char protocol_version[];

static void ss_server(User *, char *);
static void ss_map(User *);
static void ss_version(User *); 
static void ss_uptime(User *);
static void ss_netstats(User *);
static void ss_daily(User *);
static void ss_tld(User *, char *);
static void ss_tld_map(User *);
static void ss_operlist(User *, char *, char *);
static void ss_botlist(User *);
static void ss_shutdown(User *u, char *reason);
static void ss_reload(User *u, char *reason);
static void ss_reset(User *u);
static void ss_stats(User *, char *, char *, char *);
static void ss_logs(User *);
static void ss_jupe(User *, char *);
static void ss_JOIN(User *, char *);
static void ss_debug_to_coders(User *);
static void ss_raw(User *, char *);

void statserv(char *line)
{
	char *cmd, *nick = strtok(line, " ");
	User *u;
	char *reason;	
	nick++;
	cmd = strtok(NULL, " ");
	cmd = strtok(NULL, " ");
	cmd = strtok(NULL, " ");
	cmd++;
	u = finduser(nick);
	if (!u) {
		log("Unable to finduser %s (statserv)", nick);
		return;
	}

	me.requests++;

	if (flood(u))
		return;

	log("%s received message from %s: %s", s_StatServ, nick, cmd);
 
	if (me.onlyopers && !u->is_oper) {
		privmsg(u->nick, s_StatServ,
			"This service is only available to IRCops.");
		notice ("%s Requested %s, but he is Not a Operator!", u->nick, cmd);
		return;
	}

	if (!strcasecmp(cmd, "HELP")) {
		cmd = strtok(NULL, " ");
		notice("%s is a Dummy and wanted help on %s",u->nick, cmd);
		if (!cmd) {
			privmsg_list(nick, s_StatServ, ss_help);
			if (u->is_tecmin)
				privmsg_list(nick, s_StatServ, ss_myuser_help);
			if (u->is_coder)
				privmsg_list(nick, s_StatServ, ss_coder_help);
		} else if (!strcasecmp(cmd, "SERVER"))
			privmsg_list(nick, s_StatServ, ss_server_help);
		else if (!strcasecmp(cmd, "MAP"))
			privmsg_list(nick, s_StatServ, ss_map_help);
		else if (!strcasecmp(cmd, "NETSTATS"))
			privmsg_list(nick, s_StatServ, ss_netstats_help);
		else if (!strcasecmp(cmd, "DAILY"))
			privmsg_list(nick, s_StatServ, ss_daily_help);
		else if (!strcasecmp(cmd, "TLD"))
			privmsg_list(nick, s_StatServ, ss_tld_help);
		else if (!strcasecmp(cmd, "TLDMAP"))
			privmsg_list(nick, s_StatServ, ss_tld_map_help);
		else if (!strcasecmp(cmd, "OPERLIST"))
			privmsg_list(nick, s_StatServ, ss_operlist_help);
                else if (!strcasecmp(cmd, "BOTLIST"))
                        privmsg_list(nick, s_StatServ, ss_botlist_help);
                else if (!strcasecmp(cmd, "VERSION"))
                        privmsg_list(nick, s_StatServ, ss_version_help);
		else if (!strcasecmp(cmd, "SHUTDOWN") && u->is_tecmin)
			privmsg_list(nick, s_StatServ, ss_shutdown_help);
                else if (!strcasecmp(cmd, "RELOAD") && u->is_tecmin)
                        privmsg_list(nick, s_StatServ, ss_reload_help);
                else if (!strcasecmp(cmd, "RESET") && u->is_tecmin)
                        privmsg_list(nick, s_StatServ, ss_reset_help);
		else if (!strcasecmp(cmd, "STATS") && u->is_tecmin)
			privmsg_list(nick, s_StatServ, ss_stats_help);
		else if (!strcasecmp(cmd, "LOGS") && u->is_tecmin)
			privmsg_list(nick, s_StatServ, ss_logs_help);
		else if (!strcasecmp(cmd, "JOIN") && u->is_tecmin)
			privmsg_list(nick, s_StatServ, ss_join_help);
		else
			privmsg(nick, s_StatServ, "Unknown Help Topic: \2%s\2",
				cmd);
	} else if (!strcasecmp(cmd, "SERVER")) {
		cmd = strtok(NULL, " ");
		ss_server(u, cmd);
		notice("%s Wanted Server Information on %s",u->nick, cmd);
	} else if (!strcasecmp(cmd, "MAP")) {
		ss_map(u);
		notice("%s Wanted to see the Current Network MAP",u->nick);		
        } else if (!strcasecmp(cmd, "VERSION")) {
                ss_version(u);
                notice("%s Wanted to know our version number ",u->nick);
	} else if (!strcasecmp(cmd, "UPTIME")) {
		ss_uptime(u);
		notice("%s Wanted to see %s's Uptime ",u->nick,me.name);
	} else if (!strcasecmp(cmd, "NETSTATS")) {
		ss_netstats(u);
		notice("%s Wanted to see the NetStats ",u->nick);
	} else if (!strcasecmp(cmd, "DAILY")) {
		ss_daily(u);
		notice("%s Wanted to see the Daily NetStats ",u->nick);
	} else if (!strcasecmp(cmd, "TLD")) {
		cmd = strtok(NULL, " ");
		ss_tld(u, cmd);
		notice("%s Wanted to find the Country that is Represented by %s ",u->nick,cmd);
	} else if (!strcasecmp(cmd, "TLDMAP")) {
		ss_tld_map(u);
		notice("%s Wanted to see a Country Breakdown",u->nick);
	} else if (!strcasecmp(cmd, "OPERLIST")) {
		char *t;
		cmd = strtok(NULL, " ");
		t = strtok(NULL, " ");
		ss_operlist(u, cmd, t);
        } else if (!strcasecmp(cmd, "BOTLIST")) {
                ss_botlist(u);
                notice("%s Wanted to see the Bot List",u->nick);
	} else if (!strcasecmp(cmd, "SHUTDOWN")) {
                reason=strtok(NULL,"");
		notice("%s Wants me to Go to BED!!! Good Night!",u->nick);
		ss_shutdown(u,reason);
        } else if (!strcasecmp(cmd, "RELOAD")) {
                reason=strtok(NULL,"");
                notice("%s Wants me to RELOAD! Be back in a few!",u->nick);
                ss_reload(u,reason);
        } else if (!strcasecmp(cmd, "RESET")) {
                notice("%s Wants me to RESET the databases.. here goes..",u->nick);
                ss_reset(u);
	} else if (!strcasecmp(cmd, "STATS")) {
		char *t, *m;
		m = strtok(NULL, " ");
		cmd = strtok(NULL, " ");
		t = strtok(NULL, " ");
		ss_stats(u, m, cmd, t);
		notice("%s Wants to Look at my Stats!! 34/24/34",u->nick);
	} else if (!strcasecmp(cmd, "LOGS")) {
		ss_logs(u);
		notice("%s Wants to Look at my Logs!!",u->nick);
	} else if (!strcasecmp(cmd, "JUPE")) {
		ss_jupe(u, cmd);
		notice("%s Wants to JUPE this Server %s",u->nick,cmd);
	} else if (!strcasecmp(cmd, "JOIN")) {
		cmd = strtok(NULL, " ");
		ss_JOIN(u, cmd);
	} else if (!strcasecmp(cmd, "DEBUG")) {
		ss_debug_to_coders(u);
	} else if (!strcasecmp(cmd, "RAW")) {
		cmd = strtok(NULL, "");
		ss_raw(u,cmd);
	} else {
		privmsg(nick, s_StatServ, "Unknown Command: \2%s\2",
			cmd);
		notice("%s Reqested %s, but that is a Unknown Command",u->nick,cmd);
	}
}

void spam(char *line)
{
	char *rest, *nick = strtok(line, " ");
	User *u;

	nick++;
	rest = strtok(NULL, " ");
	rest = strtok(NULL, " ");
	rest = strtok(NULL, "");
	rest++;
	u = finduser(nick);
	if (!u) {
		log("Unable to find user %s (spam)", nick);
		return;
	}

	if (flood(u))
		return;

	if (u->is_oper)
		return;

	globops(me.name, "Possible Mass Message -\2(%s!%s@%s)\2- %s", u->nick,
		u->username, u->hostname, rest);
	notice("WooHoo, A Spammer has Spammed! -\2(%s!%s@%s)\2- Sent me this: %s",u->nick,u->username,u->hostname,rest);

	log("Possible Mass Message -(%s!%s@%s)- %s", u->nick, u->username,
		u->hostname, rest);
}

static void ss_server(User *u, char *server)
{
	Stats *st;
	Server *s;

	if (!server) {
		privmsg(u->nick, s_StatServ, "Syntax: /msg %s SERVER <server name>",
			s_StatServ);
		privmsg(u->nick, s_StatServ, "For additional help, /msg %s HELP",
			s_StatServ);
		return;
	}

	st = findstats(server);
	s = findserver(server);

	if (!st) {
		privmsg(u->nick, s_StatServ, "No information available on %s",
			server);
		return;
	}
	privmsg(u->nick, s_StatServ, "Statistics for %s since %s", server,
		sftime(st->starttime));
	if (!s)
		privmsg(u->nick, s_StatServ, "Server Last Seen:  %s",
			sftime(st->lastseen));
	if (s)
		privmsg(u->nick, s_StatServ, "Current Users: %-3ld (%.0f%%)", s->users,
			(float)s->users / (float)me.users * 100);
	privmsg(u->nick, s_StatServ, "Maximum Users: %-3ld %s", st->maxusers,
		sftime(st->t_maxusers));
	if (s)
		privmsg(u->nick, s_StatServ, "Current Opers: %d", s->opers);
	privmsg(u->nick, s_StatServ, "Maximum Opers: %-3d %s", st->maxopers,
		sftime(st->t_maxopers));
	privmsg(u->nick, s_StatServ, "  IRCop Kills: %d", st->operkills);
	privmsg(u->nick, s_StatServ, " Server Kills: %d", st->serverkills);
	if (s) {
	privmsg(u->nick, s_StatServ, "  Lowest Ping: %-3d %s", s->lowest_ping,
		sftime(s->t_lowest_ping));
	privmsg(u->nick, s_StatServ, " Highest Ping: %-3d %s", s->highest_ping,
		sftime(s->t_highest_ping));
	privmsg(u->nick, s_StatServ, " Current Ping: %d", s->ping);
	}
	if (st->numsplits >= 1)
	privmsg(u->nick, s_StatServ, "%s has split from the network %d time%s.",
		st->name, st->numsplits, (st->numsplits == 1) ? "" : "s");
	else
	privmsg(u->nick, s_StatServ, "%s has never split from the network.",
		st->name);
	privmsg(u->nick, s_StatServ, "End of Statistics.");
}

static void ss_map(User *u)
{
	Server *s;
	register int i;

	privmsg(u->nick, s_StatServ, "Network Map [\2NAME\2] [\2USERS/MAX\2] "
		"[\2OPERS/MAX\2] [\2LAG\2]");
	for (i = 0; i < S_TABLE_SIZE; i++) {
		for (s = serverlist[i]; s; s = s->next) {
			privmsg(u->nick, s_StatServ, "%-30s [%2d/%2d] [%2d/%2d] %d",s->name,
				s->users, s->stats->maxusers, s->opers, s->stats->maxopers,
				s->ping);
		}
	}
	privmsg(u->nick, s_StatServ, "End of Map.");
}

static void ss_version(User *u)
{
        privmsg(u->nick, s_StatServ, "\2StatServ Version Information\2");
        privmsg(u->nick, s_StatServ, "%s - %s", me.name, version,
                                me.name, version_date, version_time);
        privmsg(u->nick, s_StatServ, "http://codeworks.kamserve.com");
}

static void ss_uptime(User *u)
{
	privmsg(u->nick, s_StatServ, "Statistics Information:");
	privmsg(u->nick, s_StatServ, "%s", uptime(me.t_start));
	privmsg(u->nick, s_StatServ, "Reconnect Time: %d", me.r_time);
	privmsg(u->nick, s_StatServ, "Entries in User Hash: %ld", me.users);
	privmsg(u->nick, s_StatServ, "Entries in Server Hash: %d", me.servers);
	privmsg(u->nick, s_StatServ, "Statistic Requests: %d", me.requests);
	privmsg(u->nick, s_StatServ, "Spam Service: %s",
		(me.enable_spam) ? "Enabled" : "Disabled");
	privmsg(u->nick, s_StatServ, "User Memory Usage: %d bytes",
		sizeof(User) * me.users);
	privmsg(u->nick, s_StatServ, "Server Memory Usage: %d bytes",
		sizeof(Server) * me.servers);
	if (me.coder_debug)
		privmsg(u->nick, s_StatServ, "Debugging Mode is \2ON!\2");
	else 
		privmsg(u->nick, s_StatServ, "Debugging Mode is Disabled!");
	privmsg(u->nick, s_StatServ, "End of Information.");
}

static void ss_netstats(User *u)
{
	privmsg(u->nick, s_StatServ, "Network Statistics:");
	privmsg(u->nick, s_StatServ, "   Current Users: %ld", me.users);
	privmsg(u->nick, s_StatServ, "   Maximum Users: %-2ld %s", me.maxusers,
		sftime(me.t_maxusers));
	privmsg(u->nick, s_StatServ, "   Current Opers: %d", me.opers);
	privmsg(u->nick, s_StatServ, "   Maximum Opers: %-2d %s", me.maxopers,
		sftime(me.t_maxopers));
	privmsg(u->nick, s_StatServ, "  Users Set Away: %-2d", me.away);
	privmsg(u->nick, s_StatServ, " Current Servers: %d", me.servers);
	privmsg(u->nick, s_StatServ, " Maximum Servers: %-2d %s", me.maxservers,
		sftime(me.t_maxservers));
	privmsg(u->nick, s_StatServ, "End of Information.");
}

static void ss_daily(User *u)
{
	privmsg(u->nick, s_StatServ, "Daily Network Statistics:");
	privmsg(u->nick, s_StatServ, " ");
	privmsg(u->nick, s_StatServ, "Maximum Servers: %-2d %s", daily.servers,
		sftime(daily.t_servers));
	privmsg(u->nick, s_StatServ, "  Maximum Users: %-2d %s", daily.users,
		sftime(daily.t_users));
	privmsg(u->nick, s_StatServ, "  Maximum Opers: %-2d %s", daily.opers,
		sftime(daily.t_opers));
	privmsg(u->nick, s_StatServ, "All daily statistics are reset at midnight.");
	privmsg(u->nick, s_StatServ, "End of Information.");
}

static void ss_tld(User *u, char *tld)
{
	TLD *tmp;

	if (!tld) {
		privmsg(u->nick, s_StatServ, "Syntax: /msg %s TLD <tld>", s_StatServ);
		privmsg(u->nick, s_StatServ, "For additional help, /msg %s HELP", 
			s_StatServ);
		return;
	}

	if (*tld == '*')
		tld++;
	if (*tld == '.')
		tld++;

	tmp = findtld(tld);

	if (!tmp)
		privmsg(u->nick, s_StatServ, "Top Level Domain \2%s\2 does not exist.",
			tld);
	else
		privmsg(u->nick, s_StatServ, "%s", tmp->country);
}

static void ss_tld_map(User *u)
{
	TLD *t;

	privmsg(u->nick, s_StatServ, "Top Level Domain Statistics:");
	for (t = tldhead; t; t = t->next) {
		if (t->users != 0)
		privmsg(u->nick, s_StatServ, "%3s \2%3d\2 (%2.0f%%) -> %s", t->tld,
			t->users, (float)t->users / (float)me.users * 100, t->country);
	}
	privmsg(u->nick, s_StatServ, "End of Information.");
}

static void ss_operlist(User *origuser, char *flags, char *server)
{
	register int i, j = 0;
	int away = 0;
	register User *u;
	int tech = 0;
	int net = 0;

	if (!flags) {
		privmsg(origuser->nick, s_StatServ, "On-Line IRCops:");
		notice ("%s Requested OperList",origuser->nick);
	}		

	if (flags && !strcasecmp(flags, "NOAWAY")) {
		away = 1;
		flags = NULL;
		privmsg(origuser->nick, s_StatServ, "On-Line IRCops (Not Away):");
		notice("%s Reqested Operlist of Non-Away Opers",origuser->nick);
	}
	if (flags && !strcasecmp(flags, "tech")) {
		tech = 1;
		flags = NULL;
		privmsg(origuser->nick, s_StatServ, "On-Line Tech Admins:");
		notice("%s Reqested a Technical Administrator List",origuser->nick);
	}
	if (flags && !strcasecmp(flags, "net")) {
		net = 1;
		flags = NULL;
		privmsg(origuser->nick, s_StatServ, "On-Line Net Admins:");
		notice("%s Reqested a Network Administrator List",origuser->nick);
	}	
	if (!away && flags && strchr(flags, '.'))
		server = flags;

	for (i = 0; i < U_TABLE_SIZE; i++) {
		for (u = userlist[i]; u; u = u->next) {
			if (away && u->is_away)
				continue;
			if (tech && u->is_tecmin == 0)
				continue;
			if (net && u->is_netmin == 0)
				continue;
			if (!strcasecmp(u->server->name, me.services_name))
				continue;
			if (u->is_oper != 1)
				continue;
			if (!server) {
				if (u->is_oper != 1)	continue;
				j++;
				privmsg(origuser->nick, s_StatServ, "[%2d] %-15s %s",j, u->nick,
					u->server->name);
				continue;
			} else {
				if (strcasecmp(server, u->server->name))	continue;
				if (u->is_oper != 1)	continue;
				j++;
				privmsg(origuser->nick, s_StatServ, "[%2d] %-15s %s",j, u->nick,
					u->server->name);
				continue;
			}
		}
	}
	privmsg(origuser->nick, s_StatServ, "End of Listing.");
}


static void ss_botlist(User *origuser)
{
        register int i, j = 0;
        register User *u;
        int bot = 1;
        privmsg(origuser->nick, s_StatServ, "On-Line Bots:");
        notice("%s Reqested a Bot List",origuser->nick);
        for (i = 0; i < U_TABLE_SIZE; i++) {
                for (u = userlist[i]; u; u = u->next) {
                        if (bot && u->is_bot ==0)
                                continue;
                                j++;
                                privmsg(origuser->nick, s_StatServ, "[%2d] %-15s %s",j, u->nick,
                                        u->server->name);
                                continue;
                }
        }       
        privmsg(origuser->nick, s_StatServ, "End of Listing.");
}

static void ss_shutdown(User *u, char *reason)
{
	if (!u->is_tecmin) {
		log("Access Denied (SHUTDOWN) to %s", u->nick);
		privmsg(u->nick, s_StatServ, "Access Denied.");
		return;
	}
	/* Yes, we are very nasty like this. */
        globops(s_StatServ, "%s requested \2SHUTDOWN\2 for %s", u->nick, reason);

	close(servsock);
	SaveStats();
	log("%s [%s](%s) requested SHUTDOWN.", u->nick, u->username,
		u->hostname);
	exit(0);
}

static void ss_reload(User *u, char *reason)
{
        if (!u->is_tecmin) {
                log("Access Denied (RELOAD) to %s", u->nick);
                privmsg(u->nick, s_StatServ, "Access Denied.");
                return;
        }
        globops(s_StatServ, "%s requested \2RELOAD\2 for %s", u->nick, reason);
        log("%s requested RELOAD.", u->nick);
        close(servsock);
        init_server_hash(); 
        init_user_hash();  
        init_tld();
        me.onchan = 0;
        me.users = 0;
        me.opers = 0;
        me.away = 0;
        me.servers = 0;
        log("Connecting to %s:%d", me.uplink, me.port);
        if (servsock > 0)
                close(servsock);
        
        servsock = ConnectTo(me.uplink, me.port);
        
        if (servsock <= 0) {
                log("Unable to connect to %s", me.uplink);
        } else {
	                login();
                read_loop();
        }
        log("Reconnecting to the server in %d seconds", me.r_time);
        sleep(me.r_time);  
}

static void ss_reset(User *u)
{
        if (!u->is_tecmin) {
                log("Access Denied (RELOAD) to %s", u->nick);
                privmsg(u->nick, s_StatServ, "Access Denied.");
                return;
        }
        remove("data/nstats.db");
        remove("data/stats.db");
        globops(s_StatServ, "%s requested \2RESET\2 databases.", u->nick);
        log("%s requested RESET.", u->nick);
        globops(s_StatServ, "Rebuilding Statistics DataBase after RESET...");
}

static void ss_stats(User *u, char *cmd, char *arg, char *arg2)
{
	Stats *st;

	if (!u->is_tecmin) {
		log("Access Denied (STATS) to %s", u->nick);
		privmsg(u->nick, s_StatServ, "Access Denied.");
		return;
	}

	if (!cmd) {
		privmsg(u->nick, s_StatServ, "Syntax: /msg %s STATS [DEL|LIST|COPY]",
			s_StatServ);
		privmsg(u->nick, s_StatServ, "For additional help, /msg %s HELP",
			s_StatServ);	
		return;
	}
	if (!strcasecmp(cmd, "LIST")) {
		int i = 1;
		privmsg(u->nick, s_StatServ, "Statistics Database:");
		for (st = shead; st; st = st->next) {
			privmsg(u->nick, s_StatServ, "[%-2d] %s", i, st->name);
			i++;
		}
		privmsg(u->nick, s_StatServ, "End of List.");
		log("%s requested STATS LIST.", u->nick);
	} else if (!strcasecmp(cmd, "DEL")) {
		Stats *m = NULL;
		if (!arg) {
			privmsg(u->nick, s_StatServ, "Syntax: /msg %s STATS DEL <name>",
				s_StatServ);
			privmsg(u->nick, s_StatServ, "For additonal help, /msg %s HELP",
				s_StatServ);
			return;
		}
		st = findstats(arg);
		if (!st) {
			privmsg(u->nick, s_StatServ, "%s is not in the database!",
				arg);
			return;
		}
		for (st = shead; st; st = st->next) {
			if (!strcasecmp(arg, st->name))
				break;
			m = st;
		}
		if (m)
			m->next = st->next;
		else
			shead = st->next;
		free(st);
		privmsg(u->nick, s_StatServ, "Removed %s from the database.", arg);
		log("%s requested STATS DEL %s", u->nick, arg);
	} else if (!strcasecmp(cmd, "COPY")) {
		Server *s;

		if (!arg || !arg2) {
			privmsg(u->nick, s_StatServ, "Syntax: /msg %s STATS COPY <name> "
				" <newname>", s_StatServ);
			return;
		}
		st = findstats(arg2);
		if (st)
			free(st);

		st = findstats(arg);
		if (!st) {
			privmsg(u->nick, s_StatServ, "No entry in the database for %s",
				arg);
			return;
		}
		s = findserver(arg);
		if (s) {
			privmsg(u->nick, s_StatServ, "Server %s is online!", arg);
			return;
		}
		s = NULL;
		memcpy(st->name, arg2, sizeof(st->name));
		s = findserver(st->name);
		if (s)
			s->stats = st;
		privmsg(u->nick, s_StatServ, "Moved database entry for %s to %s",
			arg, arg2);
		log("%s requested STATS COPY %s -> %s", u->nick, arg, arg2);
	} else {
		privmsg(u->nick, s_StatServ, "Invalid Argument.");
		privmsg(u->nick, s_StatServ, "For help, /msg %s HELP", s_StatServ);
	}
}

static void ss_logs(User *u)
{
	FILE *fp;
	char buf[512];

	if (!u->is_tecmin) {
		log("Access Denied (LOGS) to %s", u->nick);
		privmsg(u->nick, s_StatServ, "Access Denied.");
		return;
	}

	log("%s requested LOGS", u->nick);
#ifdef DEBUG
	privmsg(u->nick, s_StatServ, "This command is disabled while in DEBUG.");
#else
	fp = fopen("stats.log", "r");
	if (!fp) {
		privmsg(u->nick, s_StatServ, "Unable to open stats.log");
		return;
	}
	while (fgets(buf, sizeof(buf), fp)) {
		buf[strlen(buf)] = '\0';
		privmsg(u->nick, s_StatServ, "%s", buf);
	}
	fclose(fp);
#endif
}

static void ss_jupe(User *u, char *server)
{
	if (!u->is_tecmin) {
		privmsg(u->nick, s_StatServ, "Access Denied.");
		return;
	}
	if (!server) {
		privmsg(u->nick, s_StatServ, "Syntax: /msg %s JUPE <server>",
		s_StatServ);
		return;
	}
	sts(":%s SERVER %s 1 :[Jupitered] by %s", me.name, server, u->nick);
	log("%s!%s@%s jupitered %s", u->nick, u->username, u->hostname, server);
}

static void ss_JOIN(User *u, char *chan)
{
	if (!u->is_tecmin) {
		log("Access Denied (JOIN) to %s", u->nick);
		privmsg(u->nick, s_StatServ, "Access Denied.");
		notice("%s Requested JOIN, but is not a god!",u->nick);
		return;
	}
	if (!chan) {
		privmsg(u->nick, s_StatServ, "Syntax: /msg %s JOIN <chan>",s_StatServ);
		return;
	}
	globops(me.name, "JOINING CHANNEL -\2(%s)\2- Thanks to %s!%s@%s)", chan, u->nick, u->username, u->hostname);
	privmsg(me.chan, s_StatServ, "%s Asked me to Join %s, So, I'm Leaving %s", u->nick, chan, me.chan);
	sts(":%s part %s", s_StatServ, me.chan);
	log("%s!%s@%s Asked me to Join %s, I was on %s", u->nick, u->username, u->hostname, chan, me.chan);
	sprintf(me.chan,"%s",chan);
	sts(":statserv JOIN %s",chan);
	sts(":%s MODE %s +o %s",me.name,chan,s_StatServ);
}
static void ss_debug_to_coders(User *u)
{
	if (!u->is_coder) {
		privmsg(u->nick, s_StatServ, "Permission Denied, you need to be a Coder to Enable Debug Mode!");
		return;
	}		
	if (!me.coder_debug) {
		me.coder_debug = 1;
		globops(me.name, "\2DEBUG MODE\2 Activated by %s",u->nick);
		privmsg(u->nick, s_StatServ, "Debuging Mode Enabled!");
		sts("NICK %s 1 1 %s %s %s 0 :/msg %s \2HELP\2", s_Debug, StatServ.user, StatServ.host, me.name, s_StatServ);
        	AddUser(s_Debug, StatServ.user, StatServ.host, me.name);
        } else {
        	me.coder_debug = 0;
        	globops(me.name, "\2DEBUG MODE\2 Deactivated by %s",u->nick);
        	privmsg(u->nick, s_StatServ, "Debuging Mode Disabled");
		sts(":%s QUIT :Debug Mode Deactivated by %s",s_Debug,u->nick);
		DelUser(s_Debug);
	}
}                                          
static void ss_raw(User *u, char *message)
{
	if (!u->is_tecmin) {
		privmsg(u->nick, s_StatServ, "Permission Denied, you need to be a TechAdmin to do that!");
		return;
	}
	notice("\2RAW COMMAND\2 \2%s\2 Issued a Raw Command!",u->nick);
	sts("%s",message);
}	
